import axios from '../../axiosPlanner';
import {
    FETCH_WEEK_DATA_START_REQUEST,
    FETCH_WEEK_DATA_START_SUCCESS,
    FETCH_WEEK_DATA_START_FAILURE,
    FETCH_CALENDAR_TASKS_REQUEST,

} from '../actionTypes/tasksTypes';
import {fetchAllUserProjectsSuccess} from './projectsActions';
import { fetchCalendarTasksSuccess } from './tasksActions';
import { fetchCurrentCalendarDisplayNameSuccess } from './usersActions';

export const showNotification = (message, variant="success") => {
    return {type: "SHOW_NOTIFICATION", message, variant}
}
export const hideNotification = () => {
    return {type: "HIDE_NOTIFICATION"};
};



/** weekDataStart, recieves userId returns type WEEK_DATA_START_REQUEST*/
const fetchWeekDataStartRequest = () => {
    return { type: FETCH_WEEK_DATA_START_REQUEST }
  }
  
  /** weekDataStart, recieves userId returns type WEEK_DATA_START_SUCCESS*/
  const fetchWeekDataStartSuccess = (weekData) => {
    return { type: FETCH_WEEK_DATA_START_SUCCESS, weekData }
  }
  
  /** weekDataStart, recieves userId returns type WEEK_DATA_START_FAILURE*/
  const fetchWeekDataStartFailure = (error) => {
    return { type: FETCH_WEEK_DATA_START_FAILURE, error }
  }
  
  /**fetchWeekDataStart, recieves userId ,make GET request to 'tasks/week-data-start/{userId}, recieves weekdata */
  export const fetchWeekDataStart = (userId) => {
    return async (dispatch) => {
      dispatch(fetchWeekDataStartRequest());
      try {
        console.log('fetchWeekDataStart front', userId)
        const response = await axios.get(`/tasks/week-data-start/${userId}`);
        dispatch(fetchCalendarTasksSuccess(response.data.tasks))
        dispatch(fetchAllUserProjectsSuccess(response.data.projects));
        dispatch(fetchCurrentCalendarDisplayNameSuccess(response.data.displayName));
      } catch (error) {
        dispatch(fetchWeekDataStartFailure(error.response.data));
      }
    }
  }